/*
 *  Copyright (C) 2004 Karlheinz Klingbeil (lunqual)
 *
 *    This program is free software; you can redistribute it and/or modify
 *    it under the terms of the GNU General Public License as published by
 *    the Free Software Foundation; either version 2 of the License, or
 *    (at your option) any later version.
 *    This program is distributed in the hope that it will be useful,
 *    but WITHOUT ANY WARRANTY; without even the implied warranty of
 *    MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the
 *    GNU General Public License for more details.
 *
 *    You should have received a copy of the GNU General Public License
 *    along with this program; if not, write to the Free Software
 *    Foundation, Inc., 59 Temple Place, Suite 330, Boston, MA  02111-1307  USA
 *
 */

package de.lunqual.rzpro.items.ergebnis;

public class DependencyItem {

	public static final int STATUS_NONE=0;
	public static final int STATUS_OK = 1;

	int 				id;
	String 			name;
	int				typ;
	int 				status;
	String			ok_string = "OK";
	String			not_ok= "---";

	public DependencyItem(int id,String name,int typ,String ok_string,String not_ok) {
		this.id=id;
		this.name=name;
		status=STATUS_NONE;
		this.ok_string = ok_string;
		this.not_ok=not_ok;
		this.typ = typ;
	}

	public int getId() {
		return id;
	}

	public void setId(int id) {
		this.id = id;
	}

	public String getName() {
		return name;
	}

	public void setName(String name) {
		this.name = name;
	}

	public int getStatus() {
		return status;
	}

	public void setStatus(int status) {
		this.status = status;
	}

	public int getTyp() {
		return typ;
	}
	@Override
	public String toString() {
		return  "<html>" + (status == STATUS_NONE? "<font color=\"red\"><b>" + not_ok +"</b></font>" :"<font color=\"green\"><b>" + ok_string +"</b></font>") +"&nbsp;"  + name + "</html>";
	}
}
